// FindFoldDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Std_Demo.h"
#include "FindFoldDlg.h"
#include "foxitpdfsdkstdctrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFindFoldDlg dialog


CFindFoldDlg::CFindFoldDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFindFoldDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFindFoldDlg)
	m_matchcase = FALSE;
	m_matchwholeworld = FALSE;
	m_what = _T("");
	m_strFolder = _T("");
	//}}AFX_DATA_INIT
}


void CFindFoldDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindFoldDlg)
	DDX_Control(pDX, IDC_LIST1, m_rtList);
	DDX_Check(pDX, IDC_CHECK1, m_matchcase);
	DDX_Check(pDX, IDC_CHECK2, m_matchwholeworld);
	DDX_Text(pDX, IDC_EDIT1, m_what);
	DDX_Text(pDX, IDC_EDIT2, m_strFolder);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFindFoldDlg, CDialog)
	//{{AFX_MSG_MAP(CFindFoldDlg)
	ON_BN_CLICKED(IDC_SelectFold, OnSelectFold)
	ON_BN_CLICKED(IDC_StartSearch, OnStartSearch)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindFoldDlg message handlers

int SelFolder(HWND hParent, CString &strFolder)
{
    strFolder.Empty();
 
    LPMALLOC lpMalloc;
 
    if (::SHGetMalloc(&lpMalloc) != NOERROR) return 0;
 
    WCHAR szDisplayName[_MAX_PATH];
    WCHAR szBuffer[_MAX_PATH];
    BROWSEINFO browseInfo;
    browseInfo.hwndOwner = hParent;
    browseInfo.pidlRoot = NULL; // set root at Desktop
    browseInfo.pszDisplayName = szDisplayName;
    browseInfo.lpszTitle = _T("Select a folder");
    browseInfo.ulFlags = BIF_RETURNFSANCESTORS|BIF_RETURNONLYFSDIRS;
    browseInfo.lpfn = NULL;
    browseInfo.lParam = 0;
 
    LPITEMIDLIST lpItemIDList;
    if ((lpItemIDList = ::SHBrowseForFolder(&browseInfo)) != NULL)
    {
        // Get the path of the selected folder from the    item ID list.
        if (::SHGetPathFromIDList(lpItemIDList, szBuffer))
        {
            // At this point, szBuffer contains the path the user chose.
            if (szBuffer[0] == '\0') return 0;
 
            // We have a path in szBuffer! Return it.
            strFolder = szBuffer;
            return 1;
        }
        else return 1; // strResult is empty
 
        lpMalloc->Free(lpItemIDList);
        lpMalloc->Release();
    }
    
 return 1;
} 


void CFindFoldDlg::OnSelectFold() 
{
	SelFolder(m_hWnd,m_strFolder);
	UpdateData(FALSE);

	// TODO: Add your control notification handler code here
	
}

void CFindFoldDlg::OnStartSearch() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_rtList.ResetContent();
	m_findMap.RemoveAll();
	//m_pAX->CloseFile();
    
	CFileFind  ff;
	CString strFolder=m_strFolder;
	if( strFolder.Right(1) != "\\")	
		strFolder += "\\";
	strFolder += _T("*.pdf");
    BOOL res = ff.FindFile(strFolder);
	int nCount = 0;
	CString csTemp;

	while(res)
	{
		res = ff.FindNextFile();
		CString strFileName = ff.GetFilePath();
		CFindResult result=	m_pAX->FindFileFirst(strFileName, m_what,m_matchcase,m_matchwholeworld);
		while(result!=NULL)
		{    
			csTemp.Format(_T("%i:%s"), nCount, m_what);
			m_rtList.InsertString(nCount, csTemp);
			m_findMap.SetAt ( nCount++, result );
            result = m_pAX->FindFileNext();
		}
		
	}
	ff.Close();
	
}

void CFindFoldDlg::OnOK() 
{    
	CDialog::OnOK();
	DestroyWindow();
}

void CFindFoldDlg::OnCancel() 
{
	CDialog::OnCancel();
	DestroyWindow();
}

void CFindFoldDlg::init(CFoxitPDFSDK* pAX)
{
	m_pAX = pAX;
}

void CFindFoldDlg::OnSelchangeList1() 
{
	CFindResult result;
	int nSel = m_rtList.GetCurSel();
	
	m_findMap.Lookup(nSel, result);
	
	if (  result )
	{
		CString a=m_pAX->GetFilePath();
		
		if(a != result.GetFindFileName())
			m_pAX->OpenFile(result.GetFindFileName(),_T(""));
		m_pAX->GoToSearchResult(result);
	}	
}
